use strict;
use warnings;

# @t@C
my $file = shift;

# Agp@
die "Usage: $0 FILE" unless defined $file;

# Bt@C̃I[v
open my $fh, '<', $file
    or die qq{Can't open file "$file": $!};

# CƂURL̃JEgi[
my $url_infos = {};

# DURL̈ꗗi[
my $urls = {};

# Es̓ǂݍ
while (my $line = <$fh>) {
    
    # E-1 s̍폜
    chomp $line;
    
    # E-2 URL̎擾
    my ($time, $url) = split /\s+/, $line;
    
    # E-3 u:v̕擾
    my $mtime;
    if ($time =~ /^(\d{2}:\d{2})/) {
        $mtime = $1;
    }
    
    # E-4 ANZXJEgAbv
    $url_infos->{$mtime}{$url}++;
    
    # E-5 ݂URLǉ
    $urls->{$url} = 1;
}

# Ft@C̃N[Y
close $fh;

# GURLŕבւ
my @urls = sort keys %$urls;

# HURLiwb_j̏o
print join("\t", 'time', @urls) . "\n";

# IiPʁjƂ̏o
foreach my $hour (0 .. 23) {
    foreach my $minute (0 .. 59) {
        
        # I-1 o̓R[h
        my @rec;
        
        # I-2 uyy:mmv`ɃtH[}bg
        my $mtime = sprintf("%02d:%02d", $hour, $minute);
        
        # I-3 R[hɒǉ
        push @rec, $mtime;
        
        # I-4 ƂURL̃JEgR[hɒǉ
        foreach my $url (@urls) {
            my $count = $url_infos->{$mtime}{$url} || 0;
            push @rec, $count;
        }
        
        # I-5 R[ho
        print join("\t", @rec) . "\n";;
    }
}