use strict;
use warnings;

my $info = {};

# s̓ǂݍ
while (my $line = <>) {

    # wb_΂
    next if $. == 1;

    # s̍폜
    chomp $line;

    # e̎擾
    my ($time, $url, $response_time, $size) = split /\s+/, $line;

    # 
    $info->{$url}{count}++;

    # ωԂ̍v
    $info->{$url}{response_time_total} += $response_time;

    # TCY̍v
    $info->{$url}{size_total} += $size;
}

# ωԂƕσTCY߂
foreach my $url (keys %$info) {

    # e
    my $count = $info->{$url}{count};
    my $response_time_total = $info->{$url}{response_time_total};
    my $size_total = $info->{$url}{size_total};

    # ωԂ߂
    my $response_time_average = $response_time_total / $count;
    $response_time_average = sprintf("%.1f",$response_time_average);
    $info->{$url}{response_time_average} = $response_time_average;

    # σTCY߂
    my $size_average = $size_total / $count;
    $size_average = sprintf("%.1f", $size_average);
    $info->{$url}{size_average} = $size_average;
}

# wb_̏o
my @headers = qw/url count response_time_average size_average/;
print join("\t", @headers) . "\n";

# ωԂ̍~URLёւ
my @urls = sort { $info->{$b}{response_time_average} <=>
        $info->{$a}{response_time_average} } keys %$info;

# o
foreach my $url (@urls) {

    # o̓R[h
    my @rec = (
        $url,
        $info->{$url}{count},
        $info->{$url}{response_time_average},
        $info->{$url}{size_average}
    );

    # o
    print join("\t", @rec) . "\n";
}
