use strict;
use warnings;

use Scalar::Util 'looks_like_number';

# @R}hC̎󂯎
my @nums = @ARGV;

# Alǂ̃`FbN
foreach my $num (@nums) {
    die "Arguments must be numbers"
      unless looks_like_number($num);
}

# Ből߂
my $max = max(@nums);

# Cŏl߂
my $min = min(@nums);

# Dʂ̏o
print "max: $max\n" . 
      "min:$min\n";

# Eől߂Tu[`
sub max {
    my @nums = @_;

    # E-1 ől߂
    my $max;
    foreach my $num (@nums) {
        $max = $num  if !defined $max || $num > $max;
    }
    return $max;
}

# Fŏl߂Tu[`
sub min {
    my @nums = @_;

    # F-1 ŏl߂
    my $min;
    foreach my $num (@nums) {
        $min = $num  if !defined $min || $num < $min;
    }
    return $min;
}